%define		abiversion	1.8
%define		patchlevel	22

Distribution:   CCux
Packager:	Karsten Brockmann <arcam@ccux-linux.de>

Name:		ruby
Version:	1.8.7
Release:	1
License:	GNU/GPL 
URL:		http://www.ruby-lang.org/
Group:		Development/Ruby
Source0:	%{name}-%{version}-p%{patchlevel}.tar.gz
Source1:	irb.1
Patch0:		%{name}-1.8.6.111-CVE-2007-5162.patch
Patch1:		%{name}-1.8.6.111-gcc43.patch
Patch2:		%{name}-deadcode.patch

BuildRoot:	%{_tmppath}/%{name}-buildroot
Summary:	%{name} development environment

BuildRequires:  glibc-devel
BuildRequires:  db-devel
BuildRequires:  ncurses-devel
BuildRequires:  readline-devel
BuildRequires:  openssl-devel
BuildRequires:  zlib-devel

%description
Ruby is the interpreted scripting language for quick and easy object-oriented programming.
It has many features to process text files and to do system management tasks (as in Perl).
It is simple, straight-forward, extensible, and portable.

%package	devel
Summary: 	%{name} development headers.
Group: 		%{group}            
Requires: 	%{name} = %{version}-%{release}

%description	devel
Header and include files for developing applications with %{name}.

%package	libs
Summary:	Libraries necessary to run Ruby
Group:		%{group}
Provides:	ruby(abi) = %{abiversion}
Provides:	libruby = %{version}-%{release}

%description	libs
This package includes the libruby, necessary to run Ruby.

%package	tcltk
Summary:	Tcl/Tk interface for scripting language Ruby
Group:		%{group}
Requires:	%{name}-libs = %{version}-%{release}

%description	tcltk
Tcl/Tk interface for the object-oriented scripting language Ruby.

%package	irb
Summary:	The Interactive Ruby
Group:		%{group}
Requires:	%{name} = %{version}-%{release}
Provides:	irb = %{version}-%{release}

%description	irb
The irb is acronym for Interactive Ruby.  It evaluates ruby expression
from the terminal.

%package	rdoc
Summary:	A tool to generate documentation from Ruby source files
Group:		%{group}
Requires:	%{name}-irb = %{version}-%{release}
Provides:	rdoc = %{version}-%{release}

%description	rdoc
The rdoc is a tool to generate the documentation from Ruby source files.
It supports some output formats, like HTML, Ruby interactive reference (ri),
XML and Windows Help file (chm).

%package	ri
Summary:	Ruby interactive reference
Group:		Documentation
Requires:	%{name}-rdoc = %{version}-%{release}
Provides:	ri = %{version}-%{release}

%description	ri
ri is a command line tool that displays descriptions of built-in
Ruby methods, classes and modules. For methods, it shows you the calling
sequence and a description. For classes and modules, it shows a synopsis
along with a list of the methods the class or module implements.

%post
ldconfig

%postun
ldconfig

%prep
%setup -n %{name}-%{version}-p%{patchlevel}
#%patch0 -p1 upstream
%patch1 -p1
#%patch2 -p1

%build
unset CFLAGS
unset CXXFLAGS
export CFLAGS="-O2 -march=i686 -pipe "
export CXXFLAGS=$CFLAGS

./configure \
--prefix=%_prefix \
--mandir=%_mandir \
--enable-shared \
--enable-pthread \
--enable-install-doc &&
make
make

# install irb.1 manpage
mkdir -p $RPM_BUILD_ROOT%_mandir/man1/
install -p -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%_mandir/man1/

%install
make install DESTDIR=$RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc COPYING* ChangeLog GPL LEGAL LGPL NEWS README ToDo doc/ChangeLog-1.8.0 doc/NEWS-1.8.0 sample
%_bindir/%{name}
%_bindir/erb
%_bindir/testrb
%_mandir/man1/ruby.1*
%_libdir/%{name}/site_%{name}

%files devel
%defattr(-,root,root,-)
%_libdir/lib%{name}.so
%_libdir/lib%{name}-static.a
%_libdir/%{name}/%{abiversion}/%{_host_cpu}-linux/*.h

%files libs
%defattr(-,root,root,-)
%_libdir/lib%{name}.so.%{version}
%_libdir/lib%{name}.so.%{abiversion}
%_libdir/%{name}/%{abiversion}/*.rb
%_libdir/%{name}/%{abiversion}/bigdecimal
%_libdir/%{name}/%{abiversion}/cgi
%_libdir/%{name}/%{abiversion}/date
%_libdir/%{name}/%{abiversion}/digest
%_libdir/%{name}/%{abiversion}/dl
%_libdir/%{name}/%{abiversion}/drb
%_libdir/%{name}/%{abiversion}/io
%_libdir/%{name}/%{abiversion}/net
%_libdir/%{name}/%{abiversion}/openssl
%_libdir/%{name}/%{abiversion}/optparse
%_libdir/%{name}/%{abiversion}/racc
%_libdir/%{name}/%{abiversion}/rexml
%_libdir/%{name}/%{abiversion}/rinda
%_libdir/%{name}/%{abiversion}/rss
%_libdir/%{name}/%{abiversion}/runit
%_libdir/%{name}/%{abiversion}/shell
%_libdir/%{name}/%{abiversion}/soap
%_libdir/%{name}/%{abiversion}/test
%_libdir/%{name}/%{abiversion}/uri
%_libdir/%{name}/%{abiversion}/webrick
%_libdir/%{name}/%{abiversion}/wsdl
%_libdir/%{name}/%{abiversion}/xmlrpc
%_libdir/%{name}/%{abiversion}/xsd
%_libdir/%{name}/%{abiversion}/yaml
%_libdir/%{name}/%{abiversion}/*/*.so
%_libdir/%{name}/%{abiversion}/*/digest
%_libdir/%{name}/%{abiversion}/*/io
%_libdir/%{name}/%{abiversion}/*/racc
%_libdir/%{name}/%{abiversion}/*/rbconfig.rb

%files tcltk
%defattr(-,root,root,-)
%_libdir/%{name}/%{abiversion}/*-tk.rb
%_libdir/%{name}/%{abiversion}/tcltk.rb
%_libdir/%{name}/%{abiversion}/tk
%_libdir/%{name}/%{abiversion}/tk*.rb
%_libdir/%{name}/%{abiversion}/tkextlib
%_libdir/%{name}/%{abiversion}/*/tcltklib.so
%_libdir/%{name}/%{abiversion}/*/tkutil.so

%files rdoc
%defattr(-,root,root,-)
%_bindir/rdoc
%_libdir/%{name}/%{abiversion}/rdoc

%files irb
%defattr(-,root,root,-)
%_bindir/irb
%_libdir/%{name}/%{abiversion}/irb.rb
%_libdir/%{name}/%{abiversion}/irb
%_mandir/man1/irb.1*

%files ri
%defattr(-,root,root,-)
%_bindir/ri
%_datadir/ri

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sat Jun 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.8.7-1
- Version update
* Mon Mar 10 2008 Christian Wasem <wasem@ccux-linux.de> 1.8.6-1
- Version update, added subpackages
* Sat Feb 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.8.5-3
- rebuilt against tk 8.4.14
* Mon Jan 29 2007 Christian Metzen <metzench@ccux-linux.de> 1.8.5-2
- rebuilt against latest glibc/gcc
* Wed Oct 11 2006 Christian Metzen <metzench@ccux-linux.de> 1.8.5-1
- Version update
* Wed May 03 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.8.4-1
- Initial Release
